package cn.net.cpzslibs.prot;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.bean.req.Prot10001LoginBean;
import cn.net.cpzslibs.prot.bean.res.Prot10001LoginResult;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot10001Login extends ProtBase {
	/**
	 * 是否成功
	 */
	private short iResult;
	
	private final short iTaskCode10001 = 10001;
//	private String jsonData;
//	private String sInspectorId;
	private Gson gson;
	private Prot10001LoginResult loginResult;
	
	public Prot10001Login() {
//		this.sInspectorId = sInspectorId;
		gson = new Gson();
	}
	
	public Prot10001LoginResult getLoginResult(){
		return loginResult;
	}

	/*public void dealCpzsCheck(Socket socket, DataInputStream dis,
			DataOutputStream dos, Prot10001LoginBean loginBean) throws IOException {
		recProt(socket, dos, dis, loginBean);
	}*/
	public void dealCpzsCheck(SocketCreate create, Prot10001LoginBean loginBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), loginBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10001LoginBean loginBean)
			throws IOException {
//		System.err.println("loginBean:" + loginBean.toString());
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode10001, "开始发送登录信息");
				sendProt(dos, loginBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}
	
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10001, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10001, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			loginResult = gson.fromJson(jsonData, Prot10001LoginResult.class);
		}
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10001LoginBean loginBean) throws IOException {
		String bodyContent = gson.toJson(loginBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10001, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	

}
